xref: /qemu/Makefile (revision 2e8f72ac)
1# Makefile for QEMU.
2
3ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4  $(error main directory cannot contain spaces nor colons)
5endif
6
7# Always point to the root of the build tree (needs GNU make).
8BUILD_DIR=$(CURDIR)
9
10# Before including a proper config-host.mak, assume we are in the source tree
11SRC_PATH=.
12
13# Don't use implicit rules or variables
14# we have explicit rules for everything
15MAKEFLAGS += -rR
16
17SHELL = /usr/bin/env bash -o pipefail
18
19# Usage: $(call quiet-command,command and args,"NAME","args to print")
20# This will run "command and args", and either:
21#  if V=1 just print the whole command and args
22#  otherwise print the 'quiet' output in the format "  NAME     args to print"
23# NAME should be a short name of the command, 7 letters or fewer.
24# If called with only a single argument, will print nothing in quiet mode.
25quiet-command-run = $(if $(V),,$(if $2,printf "  %-7s %s\n" $2 $3 && ))$1
26quiet-@ = $(if $(V),,@)
27quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
28
29UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30    help check-help print-% \
31    docker docker-% vm-help vm-test vm-build-%
32
33all:
34.PHONY: all clean distclean recurse-all dist msi FORCE
35
36# Don't try to regenerate Makefile or configure
37# We don't generate any of them
38Makefile: ;
39configure: ;
40
41# All following code might depend on configuration variables
42ifneq ($(wildcard config-host.mak),)
43include config-host.mak
44
45git-submodule-update:
46.git-submodule-status: git-submodule-update config-host.mak
47Makefile: .git-submodule-status
48
49.PHONY: git-submodule-update
50
51git_module_status := $(shell \
52  cd '$(SRC_PATH)' && \
53  GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54  echo $$?; \
55)
56
57ifeq (1,$(git_module_status))
58ifeq (no,$(GIT_UPDATE))
59git-submodule-update:
60	$(call quiet-command, \
61            echo && \
62            echo "GIT submodule checkout is out of date. Please run" && \
63            echo "  scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64            echo "from the source directory checkout $(SRC_PATH)" && \
65            echo && \
66            exit 1)
67else
68git-submodule-update:
69	$(call quiet-command, \
70          (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71          "GIT","$(GIT_SUBMODULES)")
72endif
73endif
74
75# 0. ensure the build tree is okay
76
77# Check that we're not trying to do an out-of-tree build from
78# a tree that's been used for an in-tree build.
79ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81$(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82seems to have been used for an in-tree build. You can fix this by running \
83"$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84endif
85endif
86
87# force a rerun of configure if config-host.mak is too old or corrupted
88ifeq ($(MESON),)
89.PHONY: config-host.mak
90x := $(shell rm -rf meson-private meson-info meson-logs)
91endif
92ifeq ($(NINJA),)
93.PHONY: config-host.mak
94x := $(shell rm -rf meson-private meson-info meson-logs)
95else
96export NINJA
97endif
98ifeq ($(wildcard build.ninja),)
99.PHONY: config-host.mak
100x := $(shell rm -rf meson-private meson-info meson-logs)
101endif
102ifeq ($(origin prefix),file)
103.PHONY: config-host.mak
104x := $(shell rm -rf meson-private meson-info meson-logs)
105endif
106
107# 1. ensure config-host.mak is up-to-date
108config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
109	@echo config-host.mak is out-of-date, running configure
110	@if test -f meson-private/coredata.dat; then \
111	  ./config.status --skip-meson; \
112	else \
113	  ./config.status && touch build.ninja.stamp; \
114	fi
115
116# 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
117# works), but otherwise never needs to be updated
118meson-private/coredata.dat: meson.stamp
119meson.stamp: config-host.mak
120	@touch meson.stamp
121
122# 3. ensure generated build files are up-to-date
123
124ifneq ($(NINJA),)
125Makefile.ninja: build.ninja
126	$(quiet-@){ \
127	  echo 'ninja-targets = \'; \
128	  $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
129	  echo 'build-files = \'; \
130	  $(NINJA) -t query build.ninja | sed -n '1,/^  input:/d; /^  outputs:/q; s/$$/ \\/p'; \
131	} > $@.tmp && mv $@.tmp $@
132-include Makefile.ninja
133
134# A separate rule is needed for Makefile dependencies to avoid -n
135build.ninja: build.ninja.stamp
136$(build-files):
137build.ninja.stamp: meson.stamp $(build-files)
138	$(NINJA) $(if $V,-v,) build.ninja && touch $@
139endif
140
141ifneq ($(MESON),)
142Makefile.mtest: build.ninja scripts/mtest2make.py
143	$(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
144-include Makefile.mtest
145endif
146
147# 4. Rules to bridge to other makefiles
148
149ifneq ($(NINJA),)
150MAKE.n = $(findstring n,$(firstword $(MAKEFLAGS)))
151MAKE.k = $(findstring k,$(firstword $(MAKEFLAGS)))
152MAKE.q = $(findstring q,$(firstword $(MAKEFLAGS)))
153MAKE.nq = $(if $(word 2, $(MAKE.n) $(MAKE.q)),nq)
154NINJAFLAGS = $(if $V,-v) $(if $(MAKE.n), -n) $(if $(MAKE.k), -k0) \
155        $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
156
157ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
158ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
159
160makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
161# "ninja -t targets" also lists all prerequisites.  If build system
162# files are marked as PHONY, however, Make will always try to execute
163# "ninja build.ninja".
164ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
165.PHONY: $(ninja-targets) run-ninja
166$(ninja-targets): run-ninja
167
168# Use "| cat" to give Ninja a more "make-y" output.  Use "+" to bypass the
169# --output-sync line.
170run-ninja: config-host.mak
171ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
172	+$(quiet-@)$(if $(MAKE.nq),@:, $(NINJA) \
173	   $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat)
174endif
175endif
176
177# Force configure to re-run if the API symbols are updated
178ifeq ($(CONFIG_PLUGIN),y)
179config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
180
181.PHONY: plugins
182plugins:
183	$(call quiet-command,\
184		$(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
185		"BUILD", "example plugins")
186endif # $(CONFIG_PLUGIN)
187
188else # config-host.mak does not exist
189config-host.mak:
190ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
191	@echo "Please call configure before running make!"
192	@exit 1
193endif
194endif # config-host.mak does not exist
195
196SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
197
198include $(SRC_PATH)/tests/Makefile.include
199
200all: recurse-all
201
202ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
203ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
204# Only keep -O and -g cflags
205.PHONY: $(ROM_DIRS_RULES)
206$(ROM_DIRS_RULES):
207	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
208
209.PHONY: recurse-all recurse-clean
210recurse-all: $(addsuffix /all, $(ROM_DIRS))
211recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
212
213######################################################################
214
215clean: recurse-clean
216	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean || :
217	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
218# avoid old build problems by removing potentially incorrect old files
219	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
220	find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
221		! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
222		! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
223		-exec rm {} +
224	rm -f TAGS cscope.* *.pod *~ */*~
225	rm -f fsdev/*.pod scsi/*.pod
226
227VERSION = $(shell cat $(SRC_PATH)/VERSION)
228
229dist: qemu-$(VERSION).tar.bz2
230
231qemu-%.tar.bz2:
232	$(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
233
234distclean: clean
235	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean -g || :
236	rm -f config-host.mak config-host.h*
237	rm -f tests/tcg/config-*.mak
238	rm -f config-all-disas.mak config.status
239	rm -f tests/qemu-iotests/common.env
240	rm -f roms/seabios/config.mak roms/vgabios/config.mak
241	rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
242	rm -f *-config-target.h *-config-devices.mak *-config-devices.h
243	rm -rf meson-private meson-logs meson-info compile_commands.json
244	rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
245	rm -f config.log
246	rm -f linux-headers/asm
247	rm -Rf .sdk
248
249find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o \( -name "*.[chsS]" -o -name "*.[ch].inc" \)
250
251.PHONY: ctags
252ctags:
253	$(call quiet-command, 			\
254		rm -f "$(SRC_PATH)/"tags, 	\
255		"CTAGS", "Remove old tags")
256	$(call quiet-command, \
257		$(find-src-path) -exec ctags 		\
258		-f "$(SRC_PATH)/"tags --append {} +,	\
259		"CTAGS", "Re-index $(SRC_PATH)")
260
261.PHONY: gtags
262gtags:
263	$(call quiet-command, 			\
264		rm -f "$(SRC_PATH)/"GTAGS; 	\
265		rm -f "$(SRC_PATH)/"GRTAGS; 	\
266		rm -f "$(SRC_PATH)/"GPATH, 	\
267		"GTAGS", "Remove old $@ files")
268	$(call quiet-command, 				\
269	        (cd $(SRC_PATH) && 			\
270		 $(find-src-path) | gtags -f -), 	\
271		"GTAGS", "Re-index $(SRC_PATH)")
272
273.PHONY: TAGS
274TAGS:
275	$(call quiet-command, 			\
276		rm -f "$(SRC_PATH)/"TAGS,	\
277		"TAGS", "Remove old $@")
278	$(call quiet-command, 				\
279		$(find-src-path) -exec etags 		\
280		-f "$(SRC_PATH)/"TAGS --append {} +, 	\
281		"TAGS", "Re-index $(SRC_PATH)")
282
283.PHONY: cscope
284cscope:
285	$(call quiet-command,			\
286		rm -f "$(SRC_PATH)/"cscope.* ,	\
287		"cscope", "Remove old $@ files")
288	$(call quiet-command, 					\
289		($(find-src-path) -print | sed -e 's,^\./,,'    \
290		> "$(SRC_PATH)/cscope.files"), 			\
291		"cscope", "Create file list")
292	$(call quiet-command, 				\
293		cscope -b -i"$(SRC_PATH)/cscope.files" 	\
294		-f"$(SRC_PATH)"/cscope.out, 		\
295		"cscope", "Re-index $(SRC_PATH)")
296
297# Needed by "meson install"
298export DESTDIR
299
300include $(SRC_PATH)/tests/docker/Makefile.include
301include $(SRC_PATH)/tests/vm/Makefile.include
302
303print-help-run = printf "  %-30s - %s\\n" "$1" "$2"
304print-help = @$(call print-help-run,$1,$2)
305
306.PHONY: help
307help:
308	@echo  'Generic targets:'
309	$(call print-help,all,Build all)
310	$(call print-help,dir/file.o,Build specified target only)
311	$(call print-help,install,Install QEMU, documentation and tools)
312	$(call print-help,ctags/gtags/TAGS,Generate tags file for editors)
313	$(call print-help,cscope,Generate cscope index)
314	$(call print-help,sparse,Run sparse on the QEMU source)
315	@echo  ''
316ifeq ($(CONFIG_PLUGIN),y)
317	@echo  'Plugin targets:'
318	$(call print-help,plugins,Build the example TCG plugins)
319	@echo  ''
320endif
321	@echo  'Cleaning targets:'
322	$(call print-help,clean,Remove most generated files but keep the config)
323	$(call print-help,distclean,Remove all generated files)
324	$(call print-help,dist,Build a distributable tarball)
325	@echo  ''
326	@echo  'Test targets:'
327	$(call print-help,check,Run all tests (check-help for details))
328	$(call print-help,bench,Run all benchmarks)
329	$(call print-help,docker,Help about targets running tests inside containers)
330	$(call print-help,vm-help,Help about targets running tests inside VM)
331	@echo  ''
332	@echo  'Documentation targets:'
333	$(call print-help,html man,Build documentation in specified format)
334	@echo  ''
335ifdef CONFIG_WIN32
336	@echo  'Windows targets:'
337	$(call print-help,installer,Build NSIS-based installer for QEMU)
338ifdef CONFIG_QGA_MSI
339	$(call print-help,msi,Build MSI-based installer for qemu-ga)
340endif
341	@echo  ''
342endif
343	$(call print-help,$(MAKE) [targets],(quiet build, default))
344	$(call print-help,$(MAKE) V=1 [targets],(verbose build))
345
346# will delete the target of a rule if commands exit with a nonzero exit status
347.DELETE_ON_ERROR:
348
349print-%:
350	@echo '$*=$($*)'
351